Index: trunk/src/lib/shell/shell_command_class.cc
===================================================================
--- trunk/src/lib/shell/shell_command_class.cc	(revision 9682)
+++ trunk/src/lib/shell/shell_command_class.cc	(revision 9869)
@@ -21,5 +21,4 @@
 
 #include "debug.h"
-#include "class_list.h"
 #include "compiler.h"
 
@@ -28,5 +27,7 @@
 namespace OrxShell
 {
-  CmdClassList* ShellCommandClass::commandClassList = NULL;
+  ObjectListDefinition(ShellCommandClass);
+
+  CmdClassList* ShellCommandClass::_commandClassList = NULL;
 
   /**
@@ -35,14 +36,12 @@
    */
   ShellCommandClass::ShellCommandClass(const std::string& className)
-      : className(className)
-  {
-    this->setClassID(CL_SHELL_COMMAND_CLASS, "ShellCommandClass");
+      : _className(className)
+  {
+    this->registerObject(this, ShellCommandClass::_objectList);
     this->setName(className);
 
-    this->classID = CL_NULL;
-
-    if (ShellCommandClass::commandClassList == NULL)
-      ShellCommandClass::commandClassList = new CmdClassList;
-    ShellCommandClass::commandClassList->push_back(this);
+    if (ShellCommandClass::_commandClassList == NULL)
+      ShellCommandClass::_commandClassList = new CmdClassList;
+    ShellCommandClass::_commandClassList->push_back(this);
   }
 
@@ -52,12 +51,12 @@
   ShellCommandClass::~ShellCommandClass()
   {
-    while(!this->commandList.empty())
-      delete this->commandList.back();
-
-    if (ShellCommandClass::commandClassList != NULL)
-    {
-      CmdClassList::iterator delClass = std::find(ShellCommandClass::commandClassList->begin(), ShellCommandClass::commandClassList->end(), this);
-      if (delClass != ShellCommandClass::commandClassList->end())
-        ShellCommandClass::commandClassList->erase(delClass);
+    while(!this->_commandList.empty())
+      delete this->_commandList.back();
+
+    if (ShellCommandClass::_commandClassList != NULL)
+    {
+      CmdClassList::iterator delClass = std::find(ShellCommandClass::_commandClassList->begin(), ShellCommandClass::_commandClassList->end(), this);
+      if (delClass != ShellCommandClass::_commandClassList->end())
+        ShellCommandClass::_commandClassList->erase(delClass);
     }
   }
@@ -68,5 +67,5 @@
   void ShellCommandClass::registerCommand(ShellCommand* command)
   {
-    this->commandList.push_back(command);
+    this->_commandList.push_back(command);
   }
 
@@ -77,7 +76,7 @@
   void ShellCommandClass::unregisterCommand(ShellCommand* command)
   {
-    CmdList::iterator delC = std::find(this->commandList.begin(), this->commandList.end(), command);
-    if (delC != this->commandList.end())
-      this->commandList.erase(delC);
+    CmdList::iterator delC = std::find(this->_commandList.begin(), this->_commandList.end(), command);
+    if (delC != this->_commandList.end())
+      this->_commandList.erase(delC);
   }
 
@@ -89,11 +88,11 @@
     // unregister all commands and Classes
     CmdClassList::iterator classIT;
-    if (ShellCommandClass::commandClassList == NULL)
+    if (ShellCommandClass::_commandClassList == NULL)
       return;
 
-    while (!ShellCommandClass::commandClassList->empty())
-      delete ShellCommandClass::commandClassList->back();
-    delete ShellCommandClass::commandClassList;
-    ShellCommandClass::commandClassList = NULL;
+    while (!ShellCommandClass::_commandClassList->empty())
+      delete ShellCommandClass::_commandClassList->back();
+    delete ShellCommandClass::_commandClassList;
+    ShellCommandClass::_commandClassList = NULL;
   }
 
@@ -107,15 +106,15 @@
   bool ShellCommandClass::getCommandListOfClass(const std::string& className, std::list<std::string>& stringList)
   {
-    if (ShellCommandClass::commandClassList == NULL)
+    if (ShellCommandClass::_commandClassList == NULL)
       return false;
 
 
     CmdClassList::const_iterator elem;
-    for(elem = ShellCommandClass::commandClassList->begin(); elem != ShellCommandClass::commandClassList->end(); elem++)
+    for(elem = ShellCommandClass::_commandClassList->begin(); elem != ShellCommandClass::_commandClassList->end(); elem++)
     {
       if (className == (*elem)->getName())
       {
         CmdList::iterator command;
-        for(command = (*elem)->commandList.begin(); command != (*elem)->commandList.end(); command++)
+        for(command = (*elem)->_commandList.begin(); command != (*elem)->_commandList.end(); command++)
           stringList.push_back((*command)->getName());
         return true;
@@ -133,11 +132,11 @@
   ShellCommandClass* ShellCommandClass::getCommandClass(const std::string& className)
   {
-    if (ShellCommandClass::commandClassList == NULL)
+    if (ShellCommandClass::_commandClassList == NULL)
       return false;
 
 
     CmdClassList::const_iterator classIT;
-    for (classIT = ShellCommandClass::commandClassList->begin(); classIT != ShellCommandClass::commandClassList->end(); classIT++)
-      if (className == (*classIT)->className)
+    for (classIT = ShellCommandClass::_commandClassList->begin(); classIT != ShellCommandClass::_commandClassList->end(); classIT++)
+      if (className == (*classIT)->_className)
         return (*classIT);
     return NULL;
@@ -152,11 +151,4 @@
   {
     return (ShellCommandClass::getCommandClass(className) != NULL);
-  }
-
-  ClassID ShellCommandClass::getClassID()
-  {
-    if (this->classID == CL_NULL)
-      this->classID = ClassList::StringToID(this->className);
-    return this->classID;
   }
 
@@ -181,5 +173,5 @@
   void ShellCommandClass::help(const std::string& className)
   {
-    if (ShellCommandClass::commandClassList == NULL)
+    if (ShellCommandClass::_commandClassList == NULL)
     {
       PRINT(0)("No Commands Registered\n");
@@ -187,15 +179,15 @@
     }
     if (className.empty())
-      PRINT(0)("===== Displaying %d registered Classes:\n", ShellCommandClass::commandClassList->size());
+      PRINT(0)("===== Displaying %d registered Classes:\n", ShellCommandClass::_commandClassList->size());
 
 
     CmdClassList::iterator classIT;
-    for (classIT = ShellCommandClass::commandClassList->begin(); classIT != ShellCommandClass::commandClassList->end(); classIT++)
-    {
-      if (className.empty() || className == (*classIT)->className)
+    for (classIT = ShellCommandClass::_commandClassList->begin(); classIT != ShellCommandClass::_commandClassList->end(); classIT++)
+    {
+      if (className.empty() || className == (*classIT)->_className)
       {
-        PRINT(0)("Class:'%s' registered %d commands: \n", (*classIT)->className.c_str(), (*classIT)->commandList.size());
+        PRINT(0)("Class:'%s' registered %d commands: \n", (*classIT)->_className.c_str(), (*classIT)->_commandList.size());
         CmdList::const_iterator cmdIT;
-        for (cmdIT = (*classIT)->commandList.begin(); cmdIT != (*classIT)->commandList.end(); cmdIT++)
+        for (cmdIT = (*classIT)->_commandList.begin(); cmdIT != (*classIT)->_commandList.end(); cmdIT++)
         {
           PRINT(0)("  command:'%s' : params:%d: ", (*cmdIT)->getCName(), (*cmdIT)->executor->getParamCount());
Index: trunk/src/lib/shell/shell_command_class.h
===================================================================
--- trunk/src/lib/shell/shell_command_class.h	(revision 9682)
+++ trunk/src/lib/shell/shell_command_class.h	(revision 9869)
@@ -25,8 +25,10 @@
   class ShellCommandClass : public BaseObject
   {
+    ObjectListDeclaration(ShellCommandClass);
+
     friend class ShellCommand;
   public:
     /** @returns the CommandClassList */
-    static const CmdClassList& getCommandClassList() { return *ShellCommandClass::commandClassList; };
+    static const CmdClassList& getCommandClassList() { return *ShellCommandClass::_commandClassList; };
 
     static bool getCommandListOfClass(const std::string& className, std::list<std::string>& stringList);
@@ -51,9 +53,8 @@
 
   private:
-    const std::string                      className;                 //!< The Name of the Class. This should match the ClassName of the Commands Class.
-    ClassID                                classID;                   //!< The classID of this Class
-    CmdList                                commandList;               //!< A list of Commands from this Class
+    const std::string                      _className;                 //!< The Name of the Class. This should match the ClassName of the Commands Class.
+    CmdList                                _commandList;               //!< A list of Commands from this Class
 
-    static CmdClassList*                   commandClassList;          //!< A list of Classes
+    static CmdClassList*                   _commandClassList;          //!< A list of Classes
   };
 }
Index: trunk/src/lib/shell/shell_completion.cc
===================================================================
--- trunk/src/lib/shell/shell_completion.cc	(revision 9682)
+++ trunk/src/lib/shell/shell_completion.cc	(revision 9869)
@@ -22,6 +22,5 @@
 #include "shell_command.h"
 
-#include "substring.h"
-#include "class_list.h"
+#include "helper_functions.h"
 #include "debug.h"
 
@@ -51,6 +50,6 @@
   bool ShellCompletion::autoComplete(std::string& input)
   {
-    long classID = CL_NULL;                          //< the classID retrieved from the Class.
-    const std::list<BaseObject*>* objectList = NULL; //< the list of Objects stored in classID's ClassList
+    ClassID classID;
+    const ObjectListBase* objectList = NULL;      //< the list of Objects stored in classID's ClassList
     bool emptyComplete = false;                      //< if the completion input is empty string. e.g ""
     long completeType = NullCompletion;              //< the Type we'd like to complete.
@@ -85,7 +84,8 @@
              (!emptyComplete && inputSplits.size() == 2))
     {
-      classID = ClassList::StringToID(inputSplits.getString(0));
-      objectList = ClassList::getList((ClassID)classID);
-      if (classID != CL_NULL)
+      objectList = ObjectListBase::getObjectList(inputSplits[0]);
+      if (objectList != NULL)
+        classID = objectList->identity();
+      if (classID != NullClass::staticClassID())
         completeType |= ObjectCompletion;
       completeType |= FunctionCompletion;
@@ -95,5 +95,5 @@
              (!emptyComplete && inputSplits.size() == 3))
     {
-      if (ClassList::exists(inputSplits[0], inputSplits[1]))
+      if (ObjectListBase::getBaseObject(inputSplits[0], inputSplits[1]))
         completeType |= FunctionCompletion;
     }
@@ -113,7 +113,7 @@
 
     if (completeType & ClassCompletion)
-      this->objectComplete(completeString, CL_SHELL_COMMAND_CLASS);
+      this->objectComplete(completeString, &ShellCommandClass::objectList());
     if (completeType & ObjectCompletion)
-      this->objectComplete(completeString, classID);
+      this->objectComplete(completeString, objectList);
     if (completeType & FunctionCompletion)
       this->commandComplete(completeString, inputSplits[0]);
@@ -133,17 +133,18 @@
    * @return true on success, false otherwise
    */
-  bool ShellCompletion::objectComplete(const std::string& objectBegin, long classID)
-  {
-    const std::list<BaseObject*>* boList = ClassList::getList((ClassID)classID);
-    if (boList != NULL)
-    {
-      CompletionType type = ObjectCompletion;
-      if (classID == CL_SHELL_COMMAND_CLASS)
-        type = ClassCompletion;
-      if (!this->addToCompleteList(*boList, objectBegin, type))
-        return false;
-    }
-    else
-      return false;
+  bool ShellCompletion::objectComplete(const std::string& objectBegin, const ObjectListBase* objectList)
+  {
+    assert (objectList != NULL);
+
+    CompletionType type = ObjectCompletion;
+    if (objectList == &ShellCommandClass::objectList())
+      type = ClassCompletion;
+
+    ObjectListBase::base_list list;
+    objectList->getBaseObjectList(&list);
+
+    if (!this->addToCompleteList(list, objectBegin, type))
+     return false;
+
     return true;
   }
@@ -321,16 +322,16 @@
     switch (type)
     {
-        default:// SHELLC_NONE
-        return typeNames[0];
-        case  ClassCompletion:
-        return typeNames[1];
-        case ObjectCompletion:
-        return typeNames[2];
-        case FunctionCompletion:
-        return typeNames[3];
-        case AliasCompletion:
-        return typeNames[4];
-        case ParamCompletion:
-        return typeNames[5];
+      default:// SHELLC_NONE
+      return typeNames[0];
+      case  ClassCompletion:
+      return typeNames[1];
+      case ObjectCompletion:
+      return typeNames[2];
+      case FunctionCompletion:
+      return typeNames[3];
+      case AliasCompletion:
+      return typeNames[4];
+      case ParamCompletion:
+      return typeNames[5];
     }
   }
Index: trunk/src/lib/shell/shell_completion.h
===================================================================
--- trunk/src/lib/shell/shell_completion.h	(revision 9682)
+++ trunk/src/lib/shell/shell_completion.h	(revision 9869)
@@ -16,4 +16,5 @@
 // FORWARD DECLARATION
 class BaseObject;
+class ObjectListBase;
 
 namespace OrxShell
@@ -50,8 +51,8 @@
       bool autoComplete(std::string& input);
 
-      static const std::string& ShellCompletion::typeToString(ShellCompletion::CompletionType type);
+      static const std::string& typeToString(ShellCompletion::CompletionType type);
 
     private:
-      bool objectComplete(const std::string& objectBegin, long classID);
+      bool objectComplete(const std::string& objectBegin, const ObjectListBase* const objectList);
       bool commandComplete(const std::string& commandBegin, const std::string& className);
       bool aliasComplete(const std::string& aliasBegin);
Index: trunk/src/lib/shell/shell_completion_plugin.cc
===================================================================
--- trunk/src/lib/shell/shell_completion_plugin.cc	(revision 9682)
+++ trunk/src/lib/shell/shell_completion_plugin.cc	(revision 9869)
@@ -21,6 +21,5 @@
 #include "shell_command.h"
 
-#include "substring.h"
-#include "class_list.h"
+#include "helper_functions.h"
 #include "loading/resource_manager.h"
 
@@ -98,5 +97,5 @@
     if (completionBegin.empty()) // if we do not yet have the beginning of the line, start with the chosen startDir.
     {
-      dir.setFileName(ResourceManager::getInstance()->getDataDir() + this->_subDir);
+      dir.setFileName(Resources::ResourceManager::getInstance()->mainGlobalPath().name() + this->_subDir);
       dir.open();
       for(unsigned int i = 0; i < dir.fileCount(); i++ )
@@ -113,5 +112,5 @@
         directoryName = completionBegin.substr(0, pos);
 
-      dir.setFileName(ResourceManager::getInstance()->getDataDir() + directoryName);
+      dir.setFileName(Resources::ResourceManager::getInstance()->mainGlobalPath().name() + directoryName);
       dir.open();
 
@@ -136,7 +135,7 @@
           continue;
         }
-        printf("%s\n", (ResourceManager::getInstance()->getDataDir() + fileName).c_str());
+	printf("%s\n", (Resources::ResourceManager::getInstance()->mainGlobalPath().name() + fileName).c_str());
         if (!nocaseCmp(completionBegin, fileName, completionBegin.size()) &&
-             ResourceManager::isInDataDir(fileName))
+	     Resources::ResourceManager::getInstance()->checkFileInMainPath(fileName))
         {
           printf("Dir %s\n", fileName.c_str());
Index: trunk/src/lib/shell/shell_input.cc
===================================================================
--- trunk/src/lib/shell/shell_input.cc	(revision 9682)
+++ trunk/src/lib/shell/shell_input.cc	(revision 9869)
@@ -24,4 +24,5 @@
 #include "compiler.h"
 #include "key_names.h"
+
 
 namespace OrxShell
@@ -31,4 +32,5 @@
   ->setAlias("help");
 
+  ObjectListDefinition(ShellInput);
 
   /**
@@ -39,8 +41,8 @@
       : Text ("")
   {
+    this->registerObject(this, ShellInput::_objectList);
+
     this->pressedKey = SDLK_FIRST;
-    this->setClassID(CL_SHELL_INPUT, "ShellInput");
-
-    this->inputLine = "";
+
     this->historyIT = ShellInput::history.begin();
     this->setHistoryLength(50);
@@ -53,5 +55,5 @@
     {
       //if (!this->isEventSubscribed(ES_SHELL, i))
-        this->subscribeEvent(ES_SHELL, i);
+      this->subscribeEvent(ES_SHELL, i);
     }
     // unsubscribe unused TODO improve.
@@ -60,5 +62,4 @@
     this->unsubscribeEvent(ES_SHELL, SDLK_PAGEUP);
     this->unsubscribeEvent(ES_SHELL, SDLK_PAGEDOWN);
-
   }
 
@@ -87,6 +88,7 @@
   void ShellInput::flush()
   {
-    this->inputLine.clear();
-    this->setText(this->inputLine);
+    this->inputLineBegin.clear();
+    this->inputLineEnd.clear();
+    this->clear();
   }
 
@@ -97,6 +99,7 @@
   void ShellInput::setInputText(const std::string& text)
   {
-    this->inputLine = text;
-    this->setText(this->inputLine);
+    this->inputLineBegin = text;
+    this->inputLineEnd.clear();
+    this->setText(text);
   }
 
@@ -114,6 +117,6 @@
     }
 
-    this->inputLine += character;
-    this->setText(this->inputLine);
+    this->inputLineBegin += character;
+    this->setText(this->inputLineBegin + this->inputLineEnd);
   }
 
@@ -130,6 +133,6 @@
     }
 
-    this->inputLine += characters;
-    this->setText(this->inputLine);
+    this->inputLineBegin += characters;
+    this->setText(this->inputLineBegin + this->inputLineEnd);
   }
 
@@ -145,9 +148,9 @@
       this->historyScrolling = false;
     }
-    if (this->inputLine.size() < characterCount)
-      characterCount = this->inputLine.size();
-
-    this->inputLine.erase(this->inputLine.size() - characterCount, this->inputLine.size());
-    this->setText(this->inputLine);
+    if (this->inputLineBegin.size() < characterCount)
+      characterCount = this->inputLineBegin.size();
+
+    this->inputLineBegin.erase(this->inputLineBegin.size() - characterCount, this->inputLineBegin.size());
+    this->setText(this->inputLineBegin + this->inputLineEnd);
   }
 
@@ -158,10 +161,9 @@
   bool ShellInput::executeCommand()
   {
-    ShellBuffer::addBufferLineStatic("Execute Command: %s\n", this->inputLine.c_str());
-
-    if (this->inputLine.empty())
+    if (this->getInput().empty())
       return false;
-
-    ShellCommand::execute(this->inputLine);
+    DebugBuffer::addBufferLineStatic("Execute Command: %s\n", this->getInput().c_str());
+
+    ShellCommand::execute(this->getInput());
 
     // removing the eventually added Entry (from scrolling) to the List
@@ -173,6 +175,6 @@
 
     // adding the new Command to the History
-    if (history.empty() || history.back() != this->inputLine)
-      this->history.push_back(this->inputLine);
+    if (history.empty() || history.back() != this->getInput())
+      this->history.push_back(this->getInput());
     if (this->history.size() > this->historyLength)
     {
@@ -193,5 +195,5 @@
     if (!this->historyScrolling)
     {
-      this->history.push_back(this->inputLine);
+      this->history.push_back(this->getInput());
       this->historyScrolling = true;
       this->historyIT = --this->history.end();
@@ -231,4 +233,30 @@
   }
 
+  /**
+   * @brief moves the cursor chars Characters to the right.
+   * @param chars how much to move the cursor.
+   */
+  void ShellInput::moveCursor(int chars)
+  {
+    if (chars > 0)
+    {
+      PRINTF(5)("move cursor %d to the right\n", chars);
+      if (chars >= (int) this->inputLineEnd.size())
+        chars = inputLineEnd.size();
+      this->inputLineBegin += this->inputLineEnd.substr(0, chars);
+      this->inputLineEnd.erase(0, chars);
+    }
+    else if (chars < 0)
+    {
+      chars = -chars;
+      PRINTF(5)("move cursor %d to the left\n", chars);
+
+      if (chars >= (int) this->inputLineBegin.size())
+	chars = inputLineBegin.size();
+      this->inputLineEnd = this->inputLineBegin.substr(this->inputLineBegin.size() - chars) + this->inputLineEnd;
+      this->inputLineBegin.erase(this->inputLineBegin.size() - chars);
+    }
+  }
+
 
   /**
@@ -237,14 +265,12 @@
   void ShellInput::help(const std::string& className, const std::string& functionName)
   {
-    printf("%s::%s\n", className.c_str(), functionName.c_str());
-
     if (className.empty())
     {
-      PRINT(0)("Help for the most important Shell-commands\n");
-      PRINT(0)("F1 - HELP; F2 - DEBUG; '`' - open/close shell\n");
-      PRINT(0)("input order:\n");
-      PRINT(0)("ClassName [objectName] function [parameter1, [parameter2 ...]]  or\n");
-      PRINT(0)("Alias [parameter]\n");
-      PRINT(0)("- Also try 'help className'");
+      PRINT(0)("== Help for the most important Shell-commands\n");
+      PRINT(0)("  F1 - HELP; F2 - DEBUG; '`' - open/close shell\n");
+      PRINT(0)("  input order:\n");
+      PRINT(0)("   ClassName [objectName] function [parameter1, [parameter2 ...]]  or\n");
+      PRINT(0)("   Alias [parameter]\n");
+      PRINT(0)("- Also try 'help className' or pushing 'TAB'\n");
     }
     else if (!className.empty() && functionName.empty())
@@ -269,17 +295,17 @@
       {
         case SDLK_BACKSPACE:
-          this->removeCharacters(1);
-          break;
+        this->removeCharacters(1);
+        break;
         case SDLK_UP:
-          this->historyMoveUp();
-          break;
+        this->historyMoveUp();
+        break;
         case SDLK_DOWN:
-          this->historyMoveDown();
-          break;
+        this->historyMoveDown();
+        break;
         default:
-          {
-            if (likely(pressedKey < 127))
-              this->addCharacter(this->pressedKey);
-          }
+        {
+          if (likely(pressedKey < 127))
+            this->addCharacter(this->pressedKey);
+        }
       }
     }
@@ -313,8 +339,20 @@
         this->pressedEvent = event.type;
       }
+      else if (event.type == SDLK_LEFT)
+      {
+        this->moveCursor(-1);
+        this->pressedKey = event.type;
+        this->pressedEvent = event.type;
+      }
+      else if (event.type == SDLK_RIGHT)
+      {
+        this->moveCursor(+1);
+        this->pressedKey = event.type;
+        this->pressedEvent = event.type;
+      }
       else if (event.type == SDLK_TAB)
       {
-        this->completion.autoComplete(this->inputLine);
-        this->setText(this->inputLine);
+        this->completion.autoComplete(this->inputLineBegin);
+        this->setText(this->getInput());
       }
       else if (event.type == SDLK_BACKSPACE)
@@ -325,4 +363,12 @@
         this->removeCharacters(1);
       }
+      else if (event.type == SDLK_DELETE)
+      {
+	if (!this->inputLineEnd.empty())
+	{
+	  this->inputLineEnd.erase(0, 1);
+	  this->setText(this->getInput());
+	}
+      }
       else if (event.type == SDLK_RETURN)
       {
Index: trunk/src/lib/shell/shell_input.h
===================================================================
--- trunk/src/lib/shell/shell_input.h	(revision 9682)
+++ trunk/src/lib/shell/shell_input.h	(revision 9869)
@@ -30,4 +30,5 @@
   class ShellInput : public Text,  public EventListener
   {
+    ObjectListDeclaration(ShellInput);
 
   public:
@@ -36,5 +37,5 @@
 
     /** @returns the inputLine */
-    const std::string& getInput() const { return this->inputLine; };
+    std::string getInput() const { return this->inputLineBegin + this->inputLineEnd; };
 
     // InputLine
@@ -54,4 +55,6 @@
     void historyMoveDown();
 
+    void moveCursor(int chars);
+
     void help(const std::string& className = "", const std::string& function = "");
 
@@ -63,5 +66,7 @@
     ShellCompletion                   completion;       //!< The Completion Interface.
 
-    std::string                       inputLine;        //!< the Char-Array of the Buffer
+    std::string                       inputLineBegin;   //!< The Line up to the cursor.
+    std::string                       inputLineEnd;     //!< The Line from the cursor on
+
     float                             repeatRate;       //!< The Repeat-Delay.
     float                             repeatDelay;      //!< The delay of the first Character of a given Character.
Index: trunk/src/lib/shell/some_shell_commands.cc
===================================================================
--- trunk/src/lib/shell/some_shell_commands.cc	(revision 9682)
+++ trunk/src/lib/shell/some_shell_commands.cc	(revision 9869)
@@ -29,25 +29,45 @@
 
 #include "network_game_rules.h"
-  SHELL_COMMAND(say, NetworkGameRules, shellSay)->setAlias("say");
+SHELL_COMMAND(say, NetworkGameRules, shellSay)->setAlias("say");
 
 #include "player_stats.h"
-  SHELL_COMMAND(nick, PlayerStats, shellNick)->setAlias("nick");
+SHELL_COMMAND(nick, PlayerStats, shellNick)->setAlias("nick");
 
-#include "class_list.h"
-  SHELL_COMMAND(debug, ClassList, ClassList::debugS)
-      ->describe("Shows all registered classes, if param1: is a valid ClassName only values of this class are shown. param2: how much output")
-      ->defaultValues(MT_NULL, 1);
+// #include "class_list.h"
+//   SHELL_COMMAND(debug, ClassList, ClassList::debugS)
+//       ->describe("Shows all registered classes, if param1: is a valid ClassName only values of this class are shown. param2: how much output")
+//       ->defaultValues(MT_NULL, 1);
 
 #include "p_node.h"
-  SHELL_COMMAND(debugNode, PNode, debugNode);
-  SHELL_COMMAND(setPosition, PNode, setAbsCoor);
+SHELL_COMMAND(debugNode, PNode, debugNode);
+SHELL_COMMAND(setPosition, PNode, setAbsCoor);
 
 #include "render_2d.h"
-  SHELL_COMMAND(toggleNodeVisibility, Render2D, toggleNodesVisibility);
+SHELL_COMMAND(toggleNodeVisibility, Render2D, toggleNodesVisibility);
 
 
 #include "material.h"
-  SHELL_COMMAND(setDiffuseTexture, Material, setDiffuseMap)
-      ->defaultValues(MT_NULL, (int)GL_TEXTURE_2D)
-      ->completionPlugin(0, CompletorFileSystem());
+SHELL_COMMAND(setDiffuseTexture, Material, setDiffuseMap)
+->defaultValues(MT_NULL, (int)GL_TEXTURE_2D)
+->completionPlugin(0, CompletorFileSystem());
 
+#include "loading/resource_manager.h"
+namespace Resources {
+  SHELL_COMMAND(debug, ResourceManager, debug);
+  SHELL_COMMAND(load, ResourceManager, loadFromLoadStringHACK);
+  SHELL_COMMAND(unload, ResourceManager, unloadAllBelowKeepLevelINT);
+}
+
+#include "loading/load_param_class_description.h"
+SHELL_COMMAND_STATIC(printAll, LoadParamClassDescription, &LoadParamClassDescription::printAll)
+->defaultValues(MT_NULL, true);
+SHELL_COMMAND_STATIC(capture, LoadParamClassDescription, &LoadParamClassDescription::captureDescriptions)
+    ->defaultValues(true);
+
+#include "loading/game_loader.h"
+SHELL_COMMAND(quit, GameLoader, stop)
+    ->describe("quits the game")
+    ->setAlias("orxoquit");
+
+#include "object_list.h"
+SHELL_COMMAND_STATIC(debugAll, ObjectListBase, &ObjectListBase::debugAll);
Index: trunk/src/lib/sound/Makefile.am
===================================================================
--- trunk/src/lib/sound/Makefile.am	(revision 9682)
+++ trunk/src/lib/sound/Makefile.am	(revision 9869)
@@ -7,4 +7,6 @@
 			sound_source.cc \
 			sound_buffer.cc \
+			sound_buffer_data.cc \
+			resource_sound_buffer.cc \
                         ogg_player.cc
 
@@ -12,3 +14,5 @@
 		 sound_source.h \
 		 sound_buffer.h \
+		 sound_buffer_data.h \
+		 resource_sound_buffer.h \
                  ogg_player.h
Index: trunk/src/lib/sound/ogg_player.cc
===================================================================
--- trunk/src/lib/sound/ogg_player.cc	(revision 9682)
+++ trunk/src/lib/sound/ogg_player.cc	(revision 9869)
@@ -34,19 +34,9 @@
 
 #include "helper_functions.h"
-
-#ifdef HAVE_SDL_SDL_H
-
-#include <SDL/SDL.h>
-#include <SDL/SDL_endian.h>
-
-#else
-
-#include <SDL.h>
-#include <SDL_endian.h>
-
-#endif
+#include "sdlincl.h"
 
 namespace OrxSound
 {
+  ObjectListDefinition(OggPlayer);
   /**
    * initializes an Ogg-player from a file
@@ -55,5 +45,5 @@
   OggPlayer::OggPlayer(const std::string& fileName)
   {
-    this->setClassID(CL_SOUND_OGG_PLAYER, "OggPlayer");
+    this->registerObject(this, OggPlayer::_objectList);
 
     this->state = OggPlayer::None;
@@ -276,5 +266,5 @@
         ogg->update();
       }
-      SDL_Delay(10);
+      SDL_Delay(1);
     }
     PRINTF(4)("End the AudioThread\n");
Index: trunk/src/lib/sound/ogg_player.h
===================================================================
--- trunk/src/lib/sound/ogg_player.h	(revision 9682)
+++ trunk/src/lib/sound/ogg_player.h	(revision 9869)
@@ -13,5 +13,5 @@
 #include <ogg/ogg.h>
 #include <vorbis/vorbisfile.h>
-#include "threading.h"
+#include "util/threading.h"
 
 struct File;
@@ -25,4 +25,6 @@
   class OggPlayer : public BaseObject
   {
+    ObjectListDeclaration(OggPlayer);
+
   public:
     /**
@@ -98,8 +100,8 @@
 
 
-    std::string         _title;
-    std::string         _artist;
-    std::string         _album;
-    std::string         _vendor;
+    std::string         _title;               //!< Song Title.
+    std::string         _artist;              //!< Artist Name of the current song.
+    std::string         _album;               //!< Album Name of the current song.
+    std::string         _vendor;              //!< Vendor Name of the current song.
   };
 
Index: trunk/src/lib/sound/resource_sound_buffer.cc
===================================================================
--- trunk/src/lib/sound/resource_sound_buffer.cc	(revision 9869)
+++ trunk/src/lib/sound/resource_sound_buffer.cc	(revision 9869)
@@ -0,0 +1,36 @@
+
+#include "resource_sound_buffer.h"
+#include "debug.h"
+
+
+namespace OrxSound
+{
+  ObjectListDefinition(ResourceSoundBuffer);
+
+  ResourceSoundBuffer::ResourceSoundBuffer(const std::string& soundName, const Resources::KeepLevel& keepLevel)
+      : SoundBuffer(), Resource(&ResourceSoundBuffer::type)
+  {
+    this->registerObject(this, ResourceSoundBuffer::_objectList);
+    Resources::StorePointer* ptr = this->acquireResource(soundName);
+
+    if (ptr)
+    {
+      assert(!static_cast<ResourceSoundBuffer::SoundBufferResourcePointer*>(ptr)->ptr().isNull());
+      PRINTF(5)("FOUND SOUND: %s\n", soundName.c_str());
+      this->acquireData(static_cast<ResourceSoundBuffer::SoundBufferResourcePointer*>(ptr)->ptr());
+    }
+    else
+    {
+      PRINTF(5)("SOUND NOT FOUND: %s\n", soundName.c_str());
+      std::string fileName = this->Resource::locateFile(soundName);
+      this->SoundBuffer::load(fileName);
+      this->Resource::addResource(new ResourceSoundBuffer::SoundBufferResourcePointer(soundName, keepLevel, this->SoundBuffer::dataPointer()));
+    }
+  }
+
+
+  Resources::tType<ResourceSoundBuffer> ResourceSoundBuffer::type("SoundBuffer");
+
+  ResourceSoundBuffer::SoundBufferResourcePointer::SoundBufferResourcePointer(const std::string& loadString, const Resources::KeepLevel& keepLevel, const SoundBufferData::Pointer& data)
+      : Resources::StorePointer(loadString, keepLevel) , pointer(data)
+{}}
